package chat.rmi;

import java.rmi.server.UnicastRemoteObject;

import java.rmi.RMISecurityManager;

 chat.server.*;

// This class is a factory for RMIChatServerImpl objects. Whenever
// a client enrolls, it creates a new RMIChatServerImpl and returns
// it to the client.

public class RMIChatEnrolImpl extends UnicastRemoteObject
     implements RMIChatEnrol
{
     ChatServer server;

     public RMIChatEnrolImpl(ChatServer server)
     throws Exception
     {
          this.server = server;

// Find out what name this object should use in the RMI registry
          String name = System.getProperty("rmiName", "chat");

// Identify this object to the registry
          java.rmi.Naming.rebind("chat", this);
     }

     public RMIChatServer enrol(String name, RMIChatClient client)
     throws java.rmi.RemoteException
     {
// Create a new RMIChatServerImpl and return it to the client
          return new RMIChatServerImpl(server, name, client);
     }
}