import chat.tcp.server.TCPChatServer;
import chat.server.ChatServer;
import chat.rmi.*;

import java.rmi.RMISecurityManager;

// This class starts up the chat application and the TCP and RMI
// front ends.

public class RunServer
{
     public static void main(String[] args)
     {
          try {

// Start the chat application
               ChatServer server = new ChatServer();

               int port = 4321;

               String portStr = System.getProperty("port");
               if (portStr != null) {
                    try {
                         port = Integer.parseInt(portStr);
                    } catch (Exception ignore) {
                    }
               }

               System.setSecurityManager(new RMISecurityManager());

// Start the RMI server
               RMIChatEnrol rmiEnrol = new RMIChatEnrolImpl(
                    server);

// Start the TCP server
               TCPChatServer tcpServer = new TCPChatServer(
                    server, port);

               tcpServer.start();
          } catch (Exception e) {
               System.out.println("Got exception starting up:");
               e.printStackTrace();
          }
     }
}