import java.net.*;
import java.io.*;

 chat.server.*;
import chat.tcp.common.TCPChatMessageTypes;
import chat.tcp.client.*;

// Class is a client for the TCPChatServer object. It reads chat
// messages from System.in and relays them to the chat server.
// It displays any information coming back from the chat server.

public class RunTCPClient extends Object implements ChatClient
{
     public RunTCPClient()
     {
     }

// Display a message when there's a new user
     public void userHasEntered(String who)
     {
          System.out.println("--- "+who+" has just entered ---");
     }
     
// Display a message when someone exits
     public void userHasLeft(String who)
     {
          System.out.println("--- "+who+" has just left ---");
     }
     
// Display a chat message
     public void incomingChat(String who, String chat)
     {
          System.out.println("<"+who+"> "+chat);
     }

     public void disconnect()
     {
          System.out.println("Chat server connection closed.");
          System.exit(0);
     }

     public static void main(String args[])
     {
          int port = 4321;

// Allow the port to be set from the command line (-Dport=4567)

          String portStr = System.getProperty("port");
          if (portStr != null) {
               try {
                    port = Integer.parseInt(portStr);
               } catch (Exception ignore) {
               }
          }

// Allow the server's host name to be specified on the command
// line (-Dhost=myhost.com)

          String hostName = System.getProperty("host");
          if (hostName == null) hostName = "localhost";

Listing 37.7  Continued
          try {


// Connect to the TCPChatServer program

               Socket clientSocket = new Socket(hostName, port);

               DataOutputStream chatOutputStream =
                    new DataOutputStream(
                         clientSocket.getOutputStream());
                    
               DataInputStream chatInputStream =
                    new DataInputStream(
                         clientSocket.getInputStream());
                    
               DataInputStream userInputStream =
                    new DataInputStream(System.in);

               System.out.println("Connected to chat server!");
// Prompt the user for a name
               System.out.print("What name do you want to use? ");
               System.out.flush();

               String myName = userInputStream.readLine();

// Send the name to the server
               chatOutputStream.writeUTF(myName);

               RunTCPClient thisClient = new RunTCPClient();

// Start up a reader thread that reads messages from the server
               TCPChatReader reader = new TCPChatReader(
                    thisClient, chatInputStream);

               reader.start();

// Read input from System.in

               while (true) {

                    String chatLine = userInputStream.readLine();

                    sendChat(chatOutputStream, chatLine);

               }

          } catch (Exception e) {
               System.out.println("Got exception:");
               e.printStackTrace();
               System.exit(1);
          }
     }

// sendChat sends a chat message to the TCPChatServer program

     public static void sendChat(DataOutputStream outStream, 
String line)
     throws IOException
     {
          outStream.writeInt(TCPChatMessageTypes.CHAT);
          outStream.writeInt(line.length());
          outStream.writeBytes(line);
     }
}