package chat.tcp.server;

import java.net.*;
import java.io.*;

 chat.server.*;

// This class implements a simple TCP server that listens
// for incoming connections. It creates a TCPChatClient object
// to handle the actual connection.

public class TCPChatServer extends Object implements Runnable
{
// serverSocket is the socket we are listening on
     protected ServerSocket serverSocket;

// server is a reference to the application object, which we
// pass to the TCPChatClients

     protected ChatServer server;
     protected Thread myThread;

     public TCPChatServer(ChatServer server, int port)	
     throws IOException
     {
          serverSocket = new ServerSocket(port);

          this.server = server;
     }

     public void run()
     {
          while (true) {
               try {
// Accept a new connection
                    Socket newConn = serverSocket.accept();

// Create a client to handle the connection
                    TCPChatClient newClient = new TCPChatClient(
                         server, newConn);

// Start the client (it's runnable)
                    newClient.start();

               } catch (Exception e) {
               }
          }
     }

     public void start()
     {
          myThread = new Thread(this);
          myThread.start();
     }

     public void stop()
     {
          myThread.stop();
          myThread = null;
     }
}